/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Invoice;
import domain.InvoiceItem;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import storage.StorageInvoice;
import storage.database.connection.ConnectionFactory;

/**
 *
 * @author student1
 */
public class DatabaseStorageInvoice implements StorageInvoice{

    @Override
    public Invoice save(Invoice invoice) throws Exception {
        Connection connection = ConnectionFactory.getInstance().getConnection();
        String query = "Insert into invoice(date_created,user_created_id,amount) values(?,?,?)";
        PreparedStatement ps = connection.prepareStatement(query,Statement.RETURN_GENERATED_KEYS);
        ps.setDate(1, new Date(invoice.getCreatedDate().getTime()));
        ps.setLong(2, invoice.getCreatedUser().getId());
        ps.setBigDecimal(3, invoice.getAmount());
        
        ps.executeUpdate();
        ResultSet rs = ps.getGeneratedKeys();
        
        if(rs.next()){
            invoice.setId(rs.getLong(1));
        }else{
            throw new Exception("ERROR: KEY IS NOT GENERATED!");
        }
        
        query = "insert into invoice_item(invoice_id,item_no,product_id,price,quantity,amount) values(?,?,?,?,?,?)";
        ps = connection.prepareStatement(query);
        for (InvoiceItem item : invoice.getItems()) {
           ps.setLong(1,invoice.getId());
           ps.setInt(2,item.getItemNumber());
           ps.setLong(3, item.getProduct().getId());
           ps.setBigDecimal(4, item.getPrice());
           ps.setBigDecimal(5, item.getQuantity());
           ps.setBigDecimal(6, item.getAmount());
           
           ps.executeUpdate();
            
        }
        connection.commit();//TO DO : Uraditi sa rollback();
        ps.close();
        return invoice;
    }
    
}
